const _Sampler2DLoader = (inputs) => {
  let _arrString = ` `;
 	 const unique = [...new Set(inputs.map(item => item.texture))]; //create one varible per unique texture; if two record repat one var is created.
    for(let i = 0; i < unique.length; i++) {
				_arrString +=  `uniform sampler2D ` + String(inputs[i]['texture']) + ";"; 
    }
  console.log(_arrString)
	return _arrString
}  

const _txtr2DLoader = (inputs) => {
  let _arrString = ` `;
    for(let i = 0; i < inputs.length; i++) {
				_arrString +=  ` vec4 _txtr`+ String(i) + ` = texture2D( ` + String(inputs[i]['texture']) + `, vUV * ` + String( (inputs[i]['repeatedness']).toFixed(1) ) + " );";
    }
	return _arrString
}  

const _smoothStepLoader = (inputs, randSteps = []) => {
  let _arrString = ` `;
  let _arr;
  if (Array.isArray(randSteps) && !randSteps.length) {
        _arr = inputs; 
      } else {
        _arr = randSteps;
      }

    for(let i = 0; i < inputs.length; i++) {
				_arrString +=  `  multi_txtr =  mix(multi_txtr, _txtr`+ String(i) + `, smoothstep(` + String(_arr[i]['smoothing'][0]) + `, ` + String(_arr[i]['smoothing'][1]) + ", vAmount));";
    }
  
	return _arrString
}  

export default function fragmentShader(dict, rand) {
  console.log(rand)
  return _Sampler2DLoader(dict) + `
    varying vec2 vUV;
    varying float vAmount;

    void main() 
    { 
			` + _txtr2DLoader(dict) + `
      vec4 multi_txtr = vec4(0,0,0,1); // 1 stands for alpha to be black, otherwise means 0 white. Note: alpha 0, can reproduce beautiful gof mountain effect.
  		` + _smoothStepLoader(dict, rand) + `
      gl_FragColor = multi_txtr;
    }  
`
}